#ifndef __COMBO_ACTOR_H
#define __COMBO_ACTOR_H

#include <nds.h>
#include "../core/core.h"
#include "../animators/animators.h"
#include "SingleActionActor.h"

/*
	An entity which can perform the following actions:
		- move through each of its single hit actors
		
	IMPORTANT: This Actor does NOT delete its animator
*/
class ComboActor {
	
	private:
	
	Console* m_console;
	SingleActionActor** m_actors;
	u8 m_actorCount;
	u8 m_currentActor;
	
	Event* m_continuationEvent;
	Event* m_animationProgressReachedEvent;
	float m_animationProgress;
	
	public:
	
	ComboActor(
		Console* console,
		SingleActionActor** actors,
		u8 actorCount
		);
	
	virtual ~ComboActor();
	
	bool IsInterruptibleBySelf();
	bool IsInterruptibleByOther();
	void Cancel();
	
	void PerformCombo(
		Event* continuationEvent,
		Event* animationProgressReachedEvent,
		float animationProgress
		);
	
	void Render();
};

#endif