#include "ComboActorFactory.h"

	
ComboActorFactory::ComboActorFactory( 
	Console* console,
	SingleActionActorFactory* singleActionActorFactory
	) {
	
	m_console = console;
	m_singleActionActorFactory = singleActionActorFactory;
}

ComboActorFactory::~ComboActorFactory() {
}
	
ComboActor* ComboActorFactory::Create( 
	Animator* animator
	) {

	u8 singleHitsInComboCount = 4;
	
	// all are deleted by ComboActor's destructor
	SingleActionActor* comboHitActor1 = m_singleActionActorFactory->Create( animator, PLAYER_PHASE_COMBO_ONE );
	SingleActionActor* comboHitActor2 = m_singleActionActorFactory->Create( animator, PLAYER_PHASE_COMBO_TWO );
	SingleActionActor* comboHitActor3 = m_singleActionActorFactory->Create( animator, PLAYER_PHASE_COMBO_THREE );
	SingleActionActor* comboHitActor4 = m_singleActionActorFactory->Create( animator, PLAYER_PHASE_COMBO_FOUR );
	SingleActionActor** actors = new SingleActionActor* [ singleHitsInComboCount ];
	actors[ 0 ] = comboHitActor1;
	actors[ 1 ] = comboHitActor2;
	actors[ 2 ] = comboHitActor3;
	actors[ 3 ] = comboHitActor4;
	
	ComboActor* comboActor = new ComboActor( m_console, actors, singleHitsInComboCount );
	
	return comboActor;
}
