#ifndef __COMBO_ACTOR_FACTORY_H
#define __COMBO_ACTOR_FACTORY_H

#include <nds.h>
#include "../core/core.h"
#include "../animators/animators.h"
#include "ComboActor.h"
#include "SingleActionActor.h"
#include "SingleActionActorFactory.h"

/*
	Makes Actors who can combo hit
*/
class ComboActorFactory {
	
	private:

	Console* m_console;
	SingleActionActorFactory* m_singleActionActorFactory;
	
	public:
	
	ComboActorFactory( 
		Console* console,
		SingleActionActorFactory* singleActionActorFactory
		);
	virtual ~ComboActorFactory();
	
	ComboActor* Create( 
		Animator* animator
		);
};

#endif