#ifndef __COMPOSITEACTOR_FACTORY_H
#define __COMPOSITEACTOR_FACTORY_H

#include <nds.h>
#include "../core/core.h"
#include "../animators/animators.h"
#include "HitCountingCompositeActor.h"
#include "ActorTypes.h"
#include "FallingDownActorFactory.h"
#include "HitRecoveringActorFactory.h"
#include "SingleActionActor.h"
#include "SingleActionActorFactory.h"
#include "ComboActorFactory.h"
#include "ChargingActor.h"
#include "ChargingActorFactory.h"
#include "UtilitiesCompositeActor.h"
#include "../framedescriptors/framedescriptors.h"
#include "RandomlyFallingCompositeActor.h"
#include "AntiStunLockCompositeActor.h"

/*
	Makes Actors
*/
class CompositeActorFactory {
	
	private:
	
	CoreUtils* m_coreUtils;
	Console* m_console;
	AnimatorFactory* m_animatorFactory;
	FallingDownActorFactory* m_fallingDownActorFactory;
	HitRecoveringActorFactory* m_hitRecoveringActorFactory;
	SingleActionActorFactory* m_singleActionActorFactory;
	ComboActorFactory* m_comboActorFactory;
	ChargingActorFactory* m_chargingActorFactory;

	UtilitiesCompositeActor* MakePlayer();
	UtilitiesCompositeActor* MakeEnemy( 
		AnimatorTypes animatorType,
		bool useAntiStunLock
		);
	
	public:
	
	CompositeActorFactory( 
		CoreUtils* coreUtils,
		Console* console,
		AnimatorFactory* animatorFactory,
		FallingDownActorFactory* fallingDownActorFactory,
		HitRecoveringActorFactory* hitRecoveringActorFactory,
		SingleActionActorFactory* singleActionActorFactory,
		ComboActorFactory* comboActorFactory,
		ChargingActorFactory* chargingActorFactory
		);
	virtual ~CompositeActorFactory();
	
	UtilitiesCompositeActor* Create( ActorTypes type );
};

#endif