#ifndef __FALLINGDOWN_ACTOR_FACTORY_H
#define __FALLINGDOWN_ACTOR_FACTORY_H

#include <nds.h>
#include "../core/core.h"
#include "../animators/animators.h"
#include "FallingDownActor.h"

/*
	Makes Actors who fall down
*/
class FallingDownActorFactory {
	
	private:
	
	static const float TOTAL_FALL_HORIZONTAL_DISTANCE = 70.0f; // in pixels
	static const u8 BOUNCE_FRAME_COUNT = 16;
	static const u8 PARABOLA_FRAME_COUNT = 60;
	static const u8 ON_GROUND_FRAME_COUNT = 40;
	
	CoreUtils* m_coreUtils;
	Console* m_console;
	
	// holds coordinates of parabola describing the flight of
	// the actor while falling down
	Coords_F m_parabola[ PARABOLA_FRAME_COUNT ];
	
	public:
	
	FallingDownActorFactory( 
		CoreUtils* coreUtils,
		Console* console
		);
	virtual ~FallingDownActorFactory();
	
	FallingDownActor* Create( 
		Animator* animator,
		bool keepOnScreen
		);
};

#endif