#include "RandomlyFallingCompositeActor.h"

RandomlyFallingCompositeActor::RandomlyFallingCompositeActor(
	CoreUtils* coreUtils,
	Console* console,
	FallingDownActor* fallingDownActor,
	SingleActionActor* hitRecoveringActor,
	MovingActor* movingActor,
	SingleActionActor* singleHitActor,
	ComboActor* comboActor,
	SingleActionActor* healActor,
	SingleActionActor* mysticalActor,
	ChargingActor* chargingActor
	) : UtilitiesCompositeActor(
		console,
		fallingDownActor,
		hitRecoveringActor,
		movingActor,
		singleHitActor,
		comboActor,
		healActor,
		mysticalActor,
		chargingActor
		) {
	
	m_coreUtils = coreUtils;
	
	console->Debug( "RandomlyFallingCompositeActor: at %p", this );
}

RandomlyFallingCompositeActor::~RandomlyFallingCompositeActor() {
	m_console->Debug( "~RandomlyFallingCompositeActor: at %p", this );
}

void RandomlyFallingCompositeActor::RecoverFromHit() { 

	// every hit has a small chance to knock down
	if( m_coreUtils->Random( 1000 ) < CHANCE_TO_FALL_DOWN_OUT_OF_THOUSAND ) {
		if( this->CanFallDownOrRecoverFromHit() ) {
			this->FallDown();
			return;
		}
	}
	
	// default behaviour
	UtilitiesCompositeActor::RecoverFromHit();
}
