#ifndef RANDOMLYFALLING_COMPOSITEACTOR_H
#define RANDOMLYFALLING_COMPOSITEACTOR_H

#include "FallingDownActor.h"
#include "MovingActor.h"
#include "SingleActionActor.h"
#include "ComboActor.h"
#include "ChargingActor.h"
#include "UtilitiesCompositeActor.h"

/*
	A composite actor that may sometimes fall down instead of 
	recovering from hits
*/
class RandomlyFallingCompositeActor : public UtilitiesCompositeActor {

	private:
	
	static const u16 CHANCE_TO_FALL_DOWN_OUT_OF_THOUSAND = 10;
	CoreUtils* m_coreUtils;
	
	public:
	
	RandomlyFallingCompositeActor(
		CoreUtils* coreUtils,
		Console* console,
		FallingDownActor* fallingDownActor,
		SingleActionActor* hitRecoveringActor,
		MovingActor* movingActor,
		SingleActionActor* singleHitActor,
		ComboActor* comboActor,
		SingleActionActor* healActor,
		SingleActionActor* mysticalActor,
		ChargingActor* chargingActor
		);
		
	virtual ~RandomlyFallingCompositeActor();
	
	virtual void RecoverFromHit();
};

#endif