#include "SingleActionActorFactory.h"

	
SingleActionActorFactory::SingleActionActorFactory( 
	CoreUtils* coreUtils,
	Console* console
	) {
	
	m_coreUtils = coreUtils;
	m_console = console;
}

SingleActionActorFactory::~SingleActionActorFactory() {
}
	
SingleActionActor* SingleActionActorFactory::Create( 
	Animator* animator,
	u8 phase
	) {

	return new SingleActionActor( 
		m_coreUtils,
		m_console, 
		animator,
		phase,
		phase
		);
}

SingleActionActor* SingleActionActorFactory::Create( 
	Animator* animator,
	u8 phase,
	u8 alternatePhase
	) {

	return new SingleActionActor( 
		m_coreUtils,
		m_console, 
		animator,
		phase,
		alternatePhase
		);
}

SingleActionActor* SingleActionActorFactory::CreateUninterruptible( 
	Animator* animator,
	u8 phase
	) {

	return new UninterruptibleSingleActionActor( 
		m_coreUtils,
		m_console, 
		animator,
		phase,
		phase
		);
}

SingleActionActor* SingleActionActorFactory::CreateUninterruptible( 
	Animator* animator,
	u8 phase,
	u8 alternatePhase
	) {

	return new UninterruptibleSingleActionActor( 
		m_coreUtils,
		m_console, 
		animator,
		phase,
		alternatePhase
		);
}