#ifndef __SINGLEACTION_ACTOR_FACTORY_H
#define __SINGLEACTION_ACTOR_FACTORY_H

#include <nds.h>
#include "../core/core.h"
#include "../animators/animators.h"
#include "SingleActionActor.h"
#include "UninterruptibleSingleActionActor.h"

/*
	Makes Actors who perform a single action, without
	looping animation
*/
class SingleActionActorFactory {
	
	private:

	CoreUtils* m_coreUtils;
	Console* m_console;
	
	public:
	
	SingleActionActorFactory( 
		CoreUtils* coreUtils,
		Console* console
		);
		
	virtual ~SingleActionActorFactory();
	
	SingleActionActor* Create( 
		Animator* animator,
		u8 phase
		);
		
	SingleActionActor* Create( 
		Animator* animator,
		u8 phase,
		u8 alternatePhase
		);
	
	
	SingleActionActor* CreateUninterruptible( 
		Animator* animator,
		u8 phase
		);
		
	SingleActionActor* CreateUninterruptible( 
		Animator* animator,
		u8 phase,
		u8 alternatePhase
		);
};

#endif