#ifndef __UNINTERRUPTIBLE_SINGLEACTION_ACTOR_H
#define __UNINTERRUPTIBLE_SINGLEACTION_ACTOR_H

#include <nds.h>
#include "../core/core.h"
#include "../animators/animators.h"
#include "SingleActionActor.h"

/*
	Like SingleActionActor, but uninterruptible during action
		
	IMPORTANT: This Actor does NOT delete its animator
*/
class UninterruptibleSingleActionActor : public SingleActionActor {

	public:
	
	UninterruptibleSingleActionActor( 
		CoreUtils* coreUtils,
		Console* console,
		Animator* animator,
		u8 phase,
		u8 alternatePhase
		);
	
	virtual ~UninterruptibleSingleActionActor();
	
	bool IsInterruptibleBySelf();
	bool IsInterruptibleByOther();
};

#endif