#ifndef UTILITIES_COMPOSITE_ACTOR_H
#define UTILITIES_COMPOSITE_ACTOR_H

#include "MovingActor.h"
#include "CompositeActor.h"

/*
	Adds utilities
*/
class UtilitiesCompositeActor : public CompositeActor {

	public:
	
	UtilitiesCompositeActor(
		Console* console,
		FallingDownActor* fallingDownActor,
		SingleActionActor* hitRecoveringActor,
		MovingActor* movingActor,
		SingleActionActor* singleHitActor,
		ComboActor* comboActor,
		SingleActionActor* healActor,
		SingleActionActor* mysticalActor,
		ChargingActor* chargingActor
		);
		
	virtual ~UtilitiesCompositeActor();
	
	Coords_F GetPosition();
	Coords_F GetCentrePosition();
	bool IsFacingRight();
	void SetIsFacingRight( bool isFacingRight );
	
	// calculates the increment per frame to get to other
	Coords_F DeltaTo( UtilitiesCompositeActor* other, float speed );
	Coords_F DeltaTo( Coords_F target, float speed );
	
	// true when facing the other actor (other actor is on the side to which I am looking)
	bool IsFacingWithinDistanceOf( UtilitiesCompositeActor* other, float distance );
	
	bool IsFacing( UtilitiesCompositeActor* other );
	bool IsWithinDistanceOfVerticallyAdjusted( UtilitiesCompositeActor* other, float distance );
	float DistanceTo( UtilitiesCompositeActor* other );
	bool IsToTheLeftOf( UtilitiesCompositeActor* other );
};

#endif