#ifndef __ANIMATOR_FACTORY_H
#define __ANIMATOR_FACTORY_H

#include <nds.h>
#include "../core/core.h"
#include "../framedescriptors/framedescriptors.h"
#include "Animator.h"

enum AnimatorTypes {
	ANIMATOR_PLAYER,
	
	ANIMATOR_SMECHER,
	ANIMATOR_SMECHER_BLUE,
	ANIMATOR_SMECHER_GREEN,
	ANIMATOR_SMECHER_PURPLE,
	ANIMATOR_SMECHER_RED,
	
	ANIMATOR_CUTITAR,
	
	ANIMATOR_MASCAT,
	ANIMATOR_MASCAT_GREEN,
	ANIMATOR_MASCAT_RED,
	
	ANIMATOR_MEISS,
	ANIMATOR_MEISS_DARK
};

/*
	Makes animators
*/
class AnimatorFactory {
	
	private:
	
	Console* m_console;
	SpriteManager* m_spriteManager;
	
	public:
	
	AnimatorFactory( 
		Console* console,
		SpriteManager* spriteManager
		);
	virtual ~AnimatorFactory();
	
	Animator* Create( AnimatorTypes type );
	Animator* Create( 
		OAMSprite* sprite,
		FrameDescriptor* frameDescriptor
		);
};

#endif