#include "BackgroundFactory.h"

BackgroundFactory::BackgroundFactory( Console* console ) {
	m_console = console;
}

BackgroundFactory::~BackgroundFactory() {
}
	
StageBackground* BackgroundFactory::Create( 
	BackgroundTypes type,
	FuncBool* canScroll
	) {

	switch( type ) {
	
		case CIRCUS_PARK_BUILDINGS:
			return new CircusParkBuildings( m_console, canScroll );
		case CIRCUS_PARK_CIRCUS:
			return new CircusParkCircus( m_console, canScroll );
		case BROOKLYN_BRIDGE:
			return new BrooklynBridge( m_console, canScroll );
		case PEOPLES_HOUSE:
			return new PeoplesHouse( m_console, canScroll );
		case CORE_STAGE:
			return new CoreStage( m_console, canScroll );
		case PEOPLES_PARK:
			return new PeoplesPark( m_console, canScroll );
		case SCOTLAND:
			return new ScotlandStage( m_console, canScroll );
		case STATUE_OF_LIBERTY:
			return new StatueOfLiberty( m_console, canScroll );
		case TEMPLE_OF_HEAVEN:
			return new TempleOfHeaven( m_console, canScroll );
		case WINDSOR:
			return new WindsorStage( m_console, canScroll );
		
		case MAIN_MENU:
			return new MainMenuBackground( m_console, canScroll );
		case BEFORE_CIRCUS_PARK:
			return new BeforeCircusPark( m_console, canScroll );
		case BEFORE_PEOPLES_HOUSE:
			return new BeforePeoplesHouse( m_console, canScroll );
		
		case ROMANIAN_BOSS:
			return new RomanianBoss( m_console, canScroll );
		
		
		case BEFORE_USA:
			return new BeforeUsaIntro( m_console, canScroll );
		
		case USA_BOSS:
			return new UsaBoss( m_console, canScroll );
		
		
		case BEFORE_PEOPLES_PARK:
			return new BeforePeoplesPark( m_console, canScroll );
		case BEFORE_TEMPLE_OF_HEAVEN:
			return new BeforeTemple( m_console, canScroll );
		
		case CHINESE_BOSS:
			return new ChinaBoss( m_console, canScroll );
		
		
		case BEFORE_SCOTLAND:
			return new BeforeScotlandIntro( m_console, canScroll );
		case BEFORE_WINDSOR_CASTLE:
			return new BeforeWindsorIntro( m_console, canScroll );
		case BEFORE_CORE_INTRO:
			return new BeforeCoreIntro( m_console, canScroll );
		case END_STAGE:
			return new EndStage( m_console, canScroll );	
	}
	
	return NULL;
}
