#ifndef __BACKGROUND_FACTORY_H
#define __BACKGROUND_FACTORY_H

#include <nds.h>
#include "../core/core.h"
#include "BackgroundTypes.h"
#include "StageBackground.h"
#include "CircusParkBuildings.h"
#include "CircusParkCircus.h"
#include "BrooklynBridge.h"
#include "PeoplesHouse.h"
#include "CoreStage.h"
#include "PeoplesPark.h"
#include "ScotlandStage.h"
#include "StatueOfLiberty.h"
#include "TempleOfHeaven.h"
#include "WindsorStage.h"
#include "BeforeCircusPark.h"
#include "RomanianBoss.h"
#include "BeforePeoplesHouse.h"
#include "MainMenuBackground.h"
#include "BeforePeoplesPark.h"
#include "BeforeTemple.h"
#include "ChinaBoss.h"
#include "BeforeUsaIntro.h"
#include "UsaBoss.h"
#include "BeforeScotlandIntro.h"
#include "BeforeWindsorIntro.h"
#include "BeforeCoreIntro.h"
#include "EndStage.h"

/*
	Makes backgrounds
*/
class BackgroundFactory {

	private:
	
	Console* m_console;

	public:
	
	BackgroundFactory( Console* console );
	virtual ~BackgroundFactory();
	
	StageBackground* Create( 
		BackgroundTypes type,
		FuncBool* canScroll
		);
};

#endif