#ifndef __STAGEBACKGROUND_H
#define __STAGEBACKGROUND_H

#include <nds.h>
#include "../core/core.h"
#include "Scroller.h"

/*
	A base class for stage backgrounds
*/
class StageBackground : public Scroller {

	private:
	
	u8 m_chunkCount;
	ScrollingBackground* m_scrollingBackground;
	u16** m_chunks;
	float m_scrollX;
	FuncBool* m_canScroll;
	
	protected:
	
	Console* m_console;
	
	void InitializeChunk(
		u8 which,
		u16* chunk
		);
	
	void Initialize(
		u32* backgroundTileData,
		u32 backgroundTileDataLength,
		u16* backgroundPaletteData,
		u32 backgroundPaletteDataLength
		);
	
	public:

	StageBackground(
		Console* console,
		u8 chunkCount,
		FuncBool* canScroll
		);
		
	virtual ~StageBackground();
	
	void ScrollBy( float amount );
	bool CanScroll();
	bool IsAtEnd();
	u16 GetCurrentScrollAmount();
	
	void IncreaseMosaicEffect();
	void ResetMosaicEffect();
	
	void Render();
};


#endif