#include "BritainController.h"

BritainController::BritainController(
	AudioPlayer* audioPlayer,
	LevelFactory* levelFactory,
	FrameRunnerResult initialConditions
) : Controller( audioPlayer, levelFactory, initialConditions ) {
}

BritainController::~BritainController() {
}

FrameRunnerResult BritainController::Run() {
	// is there even a point in starting?
	if( m_initialConditions.first <= 0 ) {
		return m_initialConditions;
	}

	FrameRunner* level = m_levelFactory->CreateTransition( BEFORE_SCOTLAND );
	Song* song = m_audioPlayer->LoadSong( MOD_JAGGEDMETAL );
	song->Play();
	
	level->Start();
	delete level;
	
	FrameRunnerResult result;
	
	level = m_levelFactory->Create( SCOTLAND, SR_SCOTLAND, m_initialConditions );
	level->Start();
	result = level->GetResult();
	delete level;
	
	if( result.first <= 0 ) {
		song->Stop();
		delete song;
		return result;
	}
	
	level = m_levelFactory->CreateTransition( BEFORE_WINDSOR_CASTLE );
	level->Start();
	delete level;
	
	level = m_levelFactory->Create( WINDSOR, SR_WINDSOR, result );
	level->Start();
	result = level->GetResult();
	delete level;
	
	if( result.first <= 0 ) {
		song->Stop();
		delete song;
		return result;
	}
		
	// we're done
	song->Stop();
	delete song;
	return result;
}
