#include "ChinaController.h"

ChinaController::ChinaController(
	AudioPlayer* audioPlayer,
	LevelFactory* levelFactory,
	FrameRunnerResult initialConditions
) : Controller( audioPlayer, levelFactory, initialConditions ) {
}

ChinaController::~ChinaController() {
}

FrameRunnerResult ChinaController::Run() {
	// is there even a point in starting?
	if( m_initialConditions.first <= 0 ) {
		return m_initialConditions;
	}

	FrameRunner* level = m_levelFactory->CreateTransition( BEFORE_PEOPLES_PARK );
	Song* song = m_audioPlayer->LoadSong( MOD_TAKEITEASY );
	song->Play();
	
	level->Start();
	delete level;
	
	FrameRunnerResult result;
	
	level = m_levelFactory->Create( PEOPLES_PARK, SR_PEOPLES_PARK, m_initialConditions );
	level->Start();
	result = level->GetResult();
	delete level;
	
	if( result.first <= 0 ) {
		song->Stop();
		delete song;
		return result;
	}
	
	level = m_levelFactory->CreateTransition( BEFORE_TEMPLE_OF_HEAVEN );
	level->Start();
	delete level;
	
	level = m_levelFactory->Create( TEMPLE_OF_HEAVEN, SR_TEMPLE_OF_HEAVEN, result );
	level->Start();
	result = level->GetResult();
	delete level;
	
	if( result.first <= 0 ) {
		song->Stop();
		delete song;
		return result;
	}
	
	level = m_levelFactory->CreateTransition( CHINESE_BOSS );
	level->Start();
	delete level;
	
	// we're done
	song->Stop();
	delete song;
	return result;
}
