#ifndef CONTROLLER_H
#define CONTROLLER_H

#include "../core/core.h"
#include "../levels/levels.h"

/*
	Controls a chunk of the game by checking the result of levels (success/failure),
	playing/stopping music, and performing other chunk-specific tasks.
*/
class Controller {
	
	protected:
	AudioPlayer* m_audioPlayer;
	LevelFactory* m_levelFactory;
	FrameRunnerResult m_initialConditions;
	
	public:
	Controller(
		AudioPlayer* audioPlayer,
		LevelFactory* levelFactory,
		FrameRunnerResult initialConditions
		);
	virtual ~Controller();
	
	virtual FrameRunnerResult Run() = 0;
};

#endif
