#ifndef CONTROLLER_FACTORY_H
#define CONTROLLER_FACTORY_H

#include "MenuController.h"
#include "RomaniaController.h"
#include "UsaController.h"
#include "ChinaController.h"
#include "BritainController.h"
#include "CoreController.h"
#include "ControllerTypes.h"

class ControllerFactory {
	
	private:
	
	Console* m_console;
	AudioPlayer* m_audioPlayer;
	LevelFactory* m_levelFactory;
	
	public:
	
	ControllerFactory(
		Console* console,
		AudioPlayer* audioPlayer,
		LevelFactory* levelFactory
		);
	virtual ~ControllerFactory();
	
	Controller* Create( 
		ControllerTypes type,
		FrameRunnerResult initialConditions
		);
};

#endif