#include "CoreController.h"

CoreController::CoreController(
	AudioPlayer* audioPlayer,
	LevelFactory* levelFactory,
	FrameRunnerResult initialConditions
) : Controller( audioPlayer, levelFactory, initialConditions ) {
}

CoreController::~CoreController() {
}

FrameRunnerResult CoreController::Run() {
	// is there even a point in starting?
	if( m_initialConditions.first <= 0 ) {
		return m_initialConditions;
	}

	FrameRunner* level = m_levelFactory->CreateTransition( BEFORE_CORE_INTRO );
	Song* song = m_audioPlayer->LoadSong( MOD_REALLYSERIOUS );
	song->Play();
	
	level->Start();
	delete level;
	
	FrameRunnerResult result;
	
	level = m_levelFactory->Create( CORE_STAGE, SR_CORE, m_initialConditions );
	level->Start();
	result = level->GetResult();
	delete level;
	
	if( result.first <= 0 ) {
		song->Stop();
		delete song;
		return result;
	}
	
	level = m_levelFactory->CreateTransition( END_STAGE );
	level->Start();
	delete level;
	
	// we're done
	song->Stop();
	delete song;
	return result;
}
