#include "RomaniaController.h"

RomaniaController::RomaniaController(
	AudioPlayer* audioPlayer,
	LevelFactory* levelFactory,
	FrameRunnerResult initialConditions
) : Controller( audioPlayer, levelFactory, initialConditions ) {
}

RomaniaController::~RomaniaController() {
}

FrameRunnerResult RomaniaController::Run() {
	// is there even a point in starting?
	if( m_initialConditions.first <= 0 ) {
		return m_initialConditions;
	}

	FrameRunner* level = m_levelFactory->CreateTransition( BEFORE_CIRCUS_PARK );
	Song* song = m_audioPlayer->LoadSong( MOD_FUNKYFIGHT );
	song->Play();
	
	level->Start();
	delete level;
	
	FrameRunnerResult result;
	
	level = m_levelFactory->Create( CIRCUS_PARK_BUILDINGS, SR_CIRCUS_PARK_BUILDINGS, m_initialConditions );
	level->Start();
	result = level->GetResult();
	delete level;
	
	if( result.first <= 0 ) {
		song->Stop();
		delete song;
		return result;
	}
	
	level = m_levelFactory->Create( CIRCUS_PARK_CIRCUS, SR_CIRCUS_PARK_CIRCUS, result );
	level->Start();
	result = level->GetResult();
	delete level;
	
	if( result.first <= 0 ) {
		song->Stop();
		delete song;
		return result;
	}
	
	level = m_levelFactory->CreateTransition( BEFORE_PEOPLES_HOUSE );
	level->Start();
	delete level;
	
	level = m_levelFactory->Create( PEOPLES_HOUSE, SR_PEOPLES_HOUSE, result );
	level->Start();
	result = level->GetResult();
	delete level;
	
	if( result.first <= 0 ) {
		song->Stop();
		delete song;
		return result;
	}
	
	level = m_levelFactory->CreateTransition( ROMANIAN_BOSS );
	level->Start();
	delete level;
	
	// we're done
	song->Stop();
	delete song;
	return result;
}
