#include "UsaController.h"

UsaController::UsaController(
	AudioPlayer* audioPlayer,
	LevelFactory* levelFactory,
	FrameRunnerResult initialConditions
) : Controller( audioPlayer, levelFactory, initialConditions ) {
}

UsaController::~UsaController() {
}

FrameRunnerResult UsaController::Run() {
	// is there even a point in starting?
	if( m_initialConditions.first <= 0 ) {
		return m_initialConditions;
	}

	FrameRunner* level = m_levelFactory->CreateTransition( BEFORE_USA );
	Song* song = m_audioPlayer->LoadSong( MOD_DARKALLEY );
	song->Play();
	
	level->Start();
	delete level;
	
	FrameRunnerResult result;
	
	level = m_levelFactory->Create( BROOKLYN_BRIDGE, SR_BROOKLYN_BRIDGE, m_initialConditions );
	level->Start();
	result = level->GetResult();
	delete level;
	
	if( result.first <= 0 ) {
		song->Stop();
		delete song;
		return result;
	}
	
	level = m_levelFactory->Create( STATUE_OF_LIBERTY, SR_STATUE_OF_LIBERTY, result );
	level->Start();
	result = level->GetResult();
	delete level;
	
	if( result.first <= 0 ) {
		song->Stop();
		delete song;
		return result;
	}
	
	level = m_levelFactory->CreateTransition( USA_BOSS );
	level->Start();
	delete level;
	
	// we're done
	song->Stop();
	delete song;
	return result;
}
