#ifndef __AUDIOPLAYER_H__
#define __AUDIOPLAYER_H__

class Song;

#include <nds.h>
#include "Song.h"
#include "SoundEffect.h"

/*
	Manages audio resources
*/
class AudioPlayer {

	private:
	
	Console* m_console;
	CoreUtils* m_coreUtils;
	
	Song* m_song; // a singleton Song

	public:
	
	AudioPlayer( 
		Console* console,
		CoreUtils* coreUtils
		);
		
	virtual ~AudioPlayer();

	Song* LoadSong( u32 songId );	
	void FreeSong( Song* song );
	
	SoundEffect* LoadSoundEffect( 
		u32 soundEffectId,
		u8 multiplexingLimit
		);
	SoundEffect* LoadSoundEffect( 
		u32 soundEffectId
		);
};



#endif
