#ifndef __CONSOLE_H__
#define __CONSOLE_H__

#include "CoreUtils.h"
#include "CustomFont.h"

/*
	Provides way to allow text-based debugging and error logging
	in a controlled fashion.
*/
class Console {

	private:
	
	bool m_isDebugEnabled;
	CoreUtils* m_coreUtils;
	CustomFont* m_customFont;
	
	public:
	
	// Allows instrumentation with very little cost to switch on or off
	Console( 
		CoreUtils* coreUtils,
		bool isDebugEnabled 
		);
		
	virtual ~Console();
	
	// A variable-argumented pass through
	virtual void Debug( const char * format, ... );
	
	// Always outputs
	virtual void Error( const char * format, ... );
	
	virtual void Print( const char * format, ... );
	void MoveCursorTo( u8 column, u8 row );
	void PrintAt( u8 column, u8 row, const char * format, ... );
	void PadBlankLine();
	void Clear();
};



#endif
