#include <nds.h>
#include "CustomFont.h"
#include "font.h"

CustomFont::CustomFont() {
	m_font = NULL;
}

CustomFont::~CustomFont() {
	if( NULL != m_font ) {
		delete m_font;
	}
}

void CustomFont::Initialize() {

	const int tile_base = 0;
	const int map_base = 20;

	PrintConsole *console = consoleInit(
		0,
		0, 
		BgType_Text4bpp, 
		BgSize_T_256x256, 
		map_base, 
		tile_base, 
		false, 
		false
		);

	m_font = new ConsoleFont;
	
	m_font->gfx = (u16*)fontTiles;
	m_font->pal = (u16*)fontPal;
	m_font->numChars = 95;
	m_font->numColors =  fontPalLen / 2;
	m_font->bpp = 4;
	m_font->asciiOffset = 32;
	m_font->convertSingleColor = false;
	
	consoleSetFont( console, m_font );
}