#ifndef __FRAMERUNNER_H
#define __FRAMERUNNER_H

#include <nds.h>
#include "DataTypes.h"

/*
	Provides a few abstract functions for rendering, as well as a global frame counter,
	and end-of-frame boilerplate.
*/
class FrameRunner{

	private:
	
	u32 m_globalFrameCounter;

	protected:
	
	u32 GetGlobalFrameCounter();
	virtual bool IsDone() = 0;

	public: 
	
	FrameRunner();
	virtual ~FrameRunner();
	
	void Start();
	virtual FrameRunnerResult GetResult() = 0;
	
	// abstract functions
	virtual void Pre() = 0;
	virtual void Frame() = 0;
	virtual void Post() = 0;
};

#endif