#include "InputManager.h"

InputManager::InputManager( Console* console ) {
	m_console = console;
	m_keysDownFlags = 0;
	this->Scan();
	m_console->Debug( "InputManager: at %p", this );
}

InputManager::~InputManager() {
}

bool InputManager::IsButtonPressed( Buttons which ) {
	return m_keysDownFlags & which;
}

bool InputManager::IsButtonTapped( Buttons which ) {
	bool downPreviously = m_lastKeysDownFlags & which;
	bool downNow = m_keysDownFlags & which;

	return !downPreviously && downNow;
}

void InputManager::Scan() {
	scanKeys();
	m_lastKeysDownFlags = m_keysDownFlags;
	m_keysDownFlags = keysHeld();
}

void InputManager::Reset() {
	m_lastKeysDownFlags = 0;
	m_keysDownFlags = 0;
}