#ifndef __INPUTMANAGER_H
#define __INPUTMANAGER_H

#include <nds.h>
#include "Console.h"

enum Buttons {
	DPAD_UP = KEY_UP,
	DPAD_DOWN = KEY_DOWN,
	DPAD_LEFT = KEY_LEFT,
	DPAD_RIGHT = KEY_RIGHT,
	BUTTON_A = KEY_A,
	BUTTON_B = KEY_B,
	BUTTON_X = KEY_X,
	BUTTON_Y = KEY_Y,
	BUTTON_START = KEY_START,
	BUTTON_SELECT = KEY_SELECT
};

/*
	Provides access to reading user input
*/
class InputManager {
	
	private:
	
	Console* m_console;
	
	u32 m_lastKeysDownFlags;
	u32 m_keysDownFlags;
	
	public:
	
	InputManager( Console* console );
	
	virtual ~InputManager();
	
	void Scan();
	void Reset();
	
	// If a button is pressed and held, this will only return true once
	bool IsButtonTapped( Buttons which );
	
	// If a button is pressed and held, this will only return true for as
	// many frames as the button is held
	bool IsButtonPressed( Buttons which );
};

#endif