#include <nds.h>
#include "MainScreenOAMSprite.h"
#include "Console.h"

MainScreenOAMSprite::MainScreenOAMSprite( 
	u8 OAMSpriteIndex, 
	u8* graphicsData, 
	u16 spriteSheetWidthInPixels,
	SpritePool* spritePool,
	Console* console,
	u8* paletteData
	) : OAMSprite(
	OAMSpriteIndex, 
	graphicsData, 
	spriteSheetWidthInPixels,
	spritePool,
	console,
	&oamMain
	) {
	
	m_paletteData = paletteData;
	
	// Copy palette information to VRAM
	this->SetPalette( OAMSpriteIndex );	
	
	console->Debug( "MainScreenOAMSprite: %p", this );
}
	
MainScreenOAMSprite::~MainScreenOAMSprite() {
	m_console->Debug( "~MainScreenOAMSprite: %p", this );
}

void MainScreenOAMSprite::SetOAMSpriteIndex( 
	u8 oamSpriteIndex,
	bool forceOffScreen
	) {
	OAMSprite::SetOAMSpriteIndex( oamSpriteIndex, forceOffScreen );
	// we also have to reload palette to video ram
	this->SetPalette( oamSpriteIndex );	
}

void MainScreenOAMSprite::SetPalette( u8 OAMPaletteIndex ) {
	vramSetBankF( VRAM_F_LCD );
	dmaCopy( m_paletteData, &VRAM_F_EXT_PALETTE[ 0 ][ OAMPaletteIndex ], 512 );
	vramSetBankF( VRAM_F_SPRITE_EXT_PALETTE );
}
