#ifndef MAINSCREENSPRITEMANAGER_H
#define MAINSCREENSPRITEMANAGER_H

class OAMSprite;

#include <nds.h>
#include "OAMSprite.h"
#include "Console.h"
#include "PrioritizingSpritePool.h"

/*
	This class is responsible for creating and managing main screen OAM sprites,
	and matching them up with their palettes
*/
class MainScreenSpriteManager {

	private:
	
	// we will use one sprite per on-screen character, so this number should be enough
	// by restricting the number of sprites so severely, we also ensure that each 
	// sprite can use its own (extended) 256-colour palette
	static const u8 MAX_SPRITES = 16;
	
	Console* m_console;
	PrioritizingSpritePool* m_spritePool;
	
	public:
	
    MainScreenSpriteManager( Console* console );
	
	virtual ~MainScreenSpriteManager();
	
	OAMSprite* AllocateSprite( 
		u8* graphicsData, 
		u16 spriteSheetWidthInPixels,
		u8* paletteData
		);
		
	void ReprioritizeSprites();
}; 

 
#endif