#ifndef __SONG_H
#define __SONG_H

class AudioPlayer;

#include <nds.h>
#include "Console.h"
#include "CoreUtils.h"
#include "AudioPlayer.h"

/*
	Encapsulates song (MOD) functionality
*/
class Song {
	
	private:
	
	AudioPlayer* m_audioPlayer;
	CoreUtils* m_coreUtils;
	Console* m_console;
	u32 m_songId; // as created via make
	bool m_isPlaying;
	
	void dummy() {}
	public:
	
	Song( 
		u32 songId,
		Console* console,
		CoreUtils* coreUtils,
		AudioPlayer* audioPlayer
		);
	
	virtual ~Song();
	
	void Play();
	
	void Stop();
};

#endif