#include "SpriteManager.h"
#include "OAMSprite.h"

SpriteManager::SpriteManager( Console* console ) {
	m_console = console;
	
	m_mainScreenSpriteManager = new MainScreenSpriteManager( m_console );
	m_subScreenSpriteManager = new SubScreenSpriteManager( m_console );
	
	m_console->Debug( "SpriteManager: at %p", this );
}

SpriteManager::~SpriteManager() {

	delete m_mainScreenSpriteManager;
	delete m_subScreenSpriteManager;
	
	m_console->Debug( "~SpriteManager: at %p", this );
}

OAMSprite* SpriteManager::AllocateMainScreenSprite( 
	u8* graphicsData, 
	u16 spriteSheetWidthInPixels,
	u8* paletteData
	) {
	
	return m_mainScreenSpriteManager->AllocateSprite(
		graphicsData,
		spriteSheetWidthInPixels,
		paletteData
		);
}

OAMSprite* SpriteManager::AllocateSubScreenSprite() {
	return m_subScreenSpriteManager->AllocateSprite();
}

void SpriteManager::ReprioritizeSprites() {
	m_mainScreenSpriteManager->ReprioritizeSprites();
}