#ifndef SPRITEMANAGER_H
#define SPRITEMANAGER_H

class OAMSprite;

#include <nds.h>
#include "OAMSprite.h"
#include "Console.h"
#include "MainScreenSpriteManager.h"
#include "SubScreenSpriteManager.h"

/*
	Aggregates main and sub screen sprite managers.
	Meant as the entry point into sprite allocation code.
*/
class SpriteManager {

	private:
	
	Console* m_console;
	
	MainScreenSpriteManager* m_mainScreenSpriteManager;
	SubScreenSpriteManager* m_subScreenSpriteManager;
	
	public:
	
    SpriteManager( Console* console );
	
	virtual ~SpriteManager();
	
	OAMSprite* AllocateMainScreenSprite( 
		u8* graphicsData, 
		u16 spriteSheetWidthInPixels,
		u8* paletteData
		);
		
	OAMSprite* AllocateSubScreenSprite();
	
	void ReprioritizeSprites();
}; 

 
#endif