#ifndef SPRITEPOOL_H
#define SPRITEPOOL_H

class OAMSprite;

#include <nds.h>
#include "OAMSprite.h"
#include "Console.h"

/*
	Encapsulates a limited capacity pool of sprites which can be 
	allocated and de-allocated.
*/
class SpritePool {

	private:

	protected:

	u8 m_capacity;
	OAMSprite** m_sprites;
	Console* m_console;
	
	public:
	
    SpritePool( 
		Console* console,
		u8 capacity
		);
	
	virtual ~SpritePool();
	
	// Find the next available index in the sprites array; if none is found, the last index is returned,
	// and the sprite at the last index is destroyed
	u8 FindAvailableSlot();
	
	virtual void FreeSlot( OAMSprite* sprite );
	
	void AddSprite( OAMSprite* sprite );
}; 

 
#endif