#include <nds.h>
#include "spr_subscreen.h"
#include "SubScreenOAMSprite.h"

SubScreenOAMSprite::SubScreenOAMSprite( 
	u8 OAMSpriteIndex, 
	SpritePool* spritePool,
	Console* console
	) : OAMSprite(
	OAMSpriteIndex, 
	(u8*) spr_subscreenTiles, 
	256,
	spritePool,
	console,
	&oamSub
	) {
	
	// Despite my sincerest efforts, I was unable to get extended palettes to work with sub screen sprites
	// As such, sprites on the sub screen will share a single palette
	dmaCopy( (u8*) spr_subscreenPal, SPRITE_PALETTE_SUB, 512 );
	
	console->Debug( "SubScreenOAMSprite: %p", this );
}
	
SubScreenOAMSprite::~SubScreenOAMSprite() {
	m_console->Debug( "~SubScreenOAMSprite: %p", this );
}