#include "OAMSprite.h"
#include "SubScreenOAMSprite.h"
#include "SubScreenSpriteManager.h"
#include "SpritePool.h"


SubScreenSpriteManager::SubScreenSpriteManager( Console* console ) {

	m_console = console;
	
	m_spritePool = new SpritePool( m_console, MAX_SPRITES );
	
	m_console->Debug( "SubScreenSpriteManager: %p", this );
}
	
SubScreenSpriteManager::~SubScreenSpriteManager() {
	delete m_spritePool;	
	m_console->Debug( "~SubScreenSpriteManager: %p", this );
}
	
OAMSprite* SubScreenSpriteManager::AllocateSprite() {
	
	u8 slot = m_spritePool->FindAvailableSlot();
		
	OAMSprite* newSprite = new SubScreenOAMSprite( 
		slot, 
		m_spritePool,
		m_console
		);
	
	m_spritePool->AddSprite( newSprite );
		
	m_console->Debug( 
		"AllocateSprite: %p", 
		newSprite
		);
	
	return newSprite;
}