#include "SystemContext.h"

SystemContext::SystemContext() {
}

SystemContext::~SystemContext() {
}

void SystemContext::Initialize() {

	// video modes
	videoSetMode( MODE_5_2D | DISPLAY_SPR_EXT_PALETTE );
	videoSetModeSub( MODE_5_2D | DISPLAY_SPR_EXT_PALETTE );
	
	// main screen sprite memory bank
	vramSetBankB( VRAM_B_MAIN_SPRITE );
	
	// sub screen sprite memory bank
	vramSetBankD( VRAM_D_SUB_SPRITE );

	// main screen background memory bank
	vramSetBankA( VRAM_A_MAIN_BG );
	
	// VRAM bank C is reserved for the console
	vramSetBankC( VRAM_C_SUB_BG ); 
	
	// sprite OAMs
	oamInit( &oamMain, SpriteMapping_1D_128, true );
	oamInit( &oamSub, SpriteMapping_1D_128, false );
	
	// VRAM bank F is reserved for extended sprite palettes
}