#ifndef __CHARGINGENEMY_DRIVER_H
#define __CHARGINGENEMY_DRIVER_H

#include "../core/core.h"
#include "../actors/actors.h"
#include "SimpleEnemyDriver.h"
#include "../overlays/overlays.h"

/*
	Encapsulates the behaviour of enemies who can also charge the player
*/
class ChargingEnemyDriver : public SimpleEnemyDriver {
	
	private:
	
	float m_minimumChargeDistance;
	u16 m_chanceOutOfThousandToCharge;
	
	public:
	
	ChargingEnemyDriver(
		Console* console,
		CoreUtils* coreUtils,
		Character* character,
		Character* enemy,
		Impact* impact,
		bool alwaysKnockDown
		);

	virtual ~ChargingEnemyDriver();
	
	void Decision();
};

#endif