#ifndef __DRIVER_FACTORY_H
#define __DRIVER_FACTORY_H

#include "../core/core.h"
#include "../actors/actors.h"
#include "../characters/characters.h"
#include "../backgrounds/backgrounds.h"
#include "../overlays/overlays.h"
#include "Driver.h"
#include "PlayerDriver.h"
#include "DriverTypes.h"
#include "SimpleEnemyDriver.h"
#include "ChargingEnemyDriver.h"
#include "FlankingEnemyDriver.h"

/*
	Makes drivers
*/
class DriverFactory {
	
	private:

	CoreUtils* m_coreUtils;
	Console* m_console;
	InputManager* m_inputManager;
	Impact* m_impact;
	
	// enemies use this as their target
	Character* m_lastPlayerCharacter;
	
	public:
	
	DriverFactory(
		Console* console,
		CoreUtils* coreUtils,
		InputManager* inputManager,
		Impact* impact
		);

	virtual ~DriverFactory();
	
	Driver* Create(
		Character* character,
		DriverTypes type,
		List<Character>* nonPlayerCharacters,
		Scroller* scroller
		);
};

#endif