#ifndef __FLANKINGENEMY_DRIVER_H
#define __FLANKINGENEMY_DRIVER_H

#include "../core/core.h"
#include "../actors/actors.h"
#include "SimpleEnemyDriver.h"
#include "../overlays/overlays.h"

/*
	Encapsulates the behaviour of enemies who can also flank the player
*/
class FlankingEnemyDriver : public SimpleEnemyDriver {
	
	private:

	static const float MINIMUM_VERTICAL_DISTANCE_TO_BEGIN_FLANKING = 8.0f;
	static const float HORIZONTAL_OFFSET_BEHIND_TARGET = 32.0f;
	static const u16 CHANCE_TO_FLANK = 5;
	
	Coords_F m_increment;
	u16 m_incrementCount;
	
	bool TryFlank();
	
	public:
	
	FlankingEnemyDriver(
		Console* console,
		CoreUtils* coreUtils,
		Character* character,
		Character* enemy,
		Impact* impact,
		bool alwaysKnockDown
		);

	virtual ~FlankingEnemyDriver();
	
	void Decision();
};

#endif