#ifndef __SIMPLEENEMY_DRIVER_H
#define __SIMPLEENEMY_DRIVER_H

#include "../core/core.h"
#include "../actors/actors.h"
#include "Driver.h"
#include "../overlays/overlays.h"

/*
	Encapsulates the behaviour of the simplest enemies
*/
class SimpleEnemyDriver : public Driver {
	
	private:
	
	bool m_alwaysKnockDown;
	bool m_wasWalkingLastFrame;
	// number of frames remaining before we can change what we're doing
	// this prevents jittering, caused when we change our mind in quick succession
	u8 m_walkingStandingCooldown;
	u8 m_walkingStandingCooldownMax;
	Event m_singleHitOccurredEvent;
	u16 m_chanceOutOfThousandToKeepWalking;
	u16 m_chanceOutOfThousandToKeepNonWalking;
	u16 m_chanceOutOfThousandToStrikeWhenClose;
	
	void FarFromEnemy();
	void WithinStrikingDistanceOfEnemy();
	
	protected:

	Character* m_enemy;
	float m_hittingRadius;
	float m_walkingSpeedUnitsPerFrame;
	
	public:
	
	SimpleEnemyDriver(
		Console* console,
		CoreUtils* coreUtils,
		Character* character,
		Character* enemy,
		Impact* impact,
		bool alwaysKnockDown
		);

	virtual ~SimpleEnemyDriver();
	
	virtual void Decision();
};

#endif