#ifndef __ENEMY_VIEW_H
#define __ENEMY_VIEW_H

#include <nds.h>
#include "../core/core.h"
#include "../gauges/gauges.h"
#include "../mugshots/mugshots.h"
#include "../fighters/fighters.h"

/*
	Displays enemy details
*/
class EnemyView {

	private:

	static const u8 CHARACTER_NAME_COLUMN = 0;
	static const u8 CHARACTER_NAME_ROW = 7;
	
	// length of time with no activity during which the view lingers on screen
	static const u16 VISIBLE_FRAME_COUNT = 160;
	u16 m_frameCountdown;
	
	Gauge* m_lifeGauge;
	MugShot* m_mugShot;
	Fighter* m_fighter;
	Console* m_console;
		
	void Hide();
	
	public:
	
	EnemyView( 
		Console* console,
		GaugeFactory* gaugeFactory,
		MugShotFactory* mugShotFactory,
		Fighter* fighter
		);
	virtual ~EnemyView();
	
	void Update();
	void Render();
};

#endif