#include "EnemyViewFactory.h"

EnemyViewFactory::EnemyViewFactory( 
	Console* console,
	GaugeFactory* gaugeFactory,
	MugShotFactory* mugShotFactory
	) {
	
	m_console = console;
	m_gaugeFactory = gaugeFactory;
	m_mugShotFactory = mugShotFactory;
}

EnemyViewFactory::~EnemyViewFactory() {
}

EnemyView* EnemyViewFactory::Create( Fighter* player ) {
	return new EnemyView( 
		m_console,
		m_gaugeFactory,
		m_mugShotFactory,
		player
		);
}
