#ifndef __ENEMY_VIEW_FACTORY_H
#define __ENEMY_VIEW_FACTORY_H

#include <nds.h>
#include "../core/core.h"
#include "../fighters/fighters.h"
#include "../mugshots/mugshots.h"
#include "EnemyView.h"

/*
	Makes player views
*/
class EnemyViewFactory {
	
	private:
	
	Console* m_console;
	GaugeFactory* m_gaugeFactory;
	MugShotFactory* m_mugShotFactory;
	
	public:
	
	EnemyViewFactory(
		Console* console,
		GaugeFactory* gaugeFactory,
		MugShotFactory* mugShotFactory
		);
	virtual ~EnemyViewFactory();
	
	EnemyView* Create( Fighter* player );
};

#endif