#ifndef __ENTRY_POINT__H
#define __ENTRY_POINT__H

#include "../core/core.h"
#include "../controllers/controllers.h"

/*
	This represents the entry point from main. 
	Its purpose is to keep as little code as possible outside of classes.
	
	As they say, "it's objects all the way down".
*/
class EntryPoint {

	private:
	
	static const u8 CONTROLLER_COUNT = 6;
	ControllerTypes m_controllerTypes[ CONTROLLER_COUNT ];
	
	SystemContext* m_context;	
	CoreUtils* m_coreUtils;
	Console* m_console;

	AudioPlayer* m_audioPlayer;
	SoundboardFactory* m_soundBoardFactory;
	LevelFactory* m_levelFactory;
	
	ControllerFactory* m_controllerFactory;
	
	InitialPlayerStats m_initialPlayerStats;

	public:
	
	EntryPoint();
	virtual ~EntryPoint();
	
	void Run();
};

#endif