#include "Fighter.h"

Fighter::Fighter(
	Console* console,
	Character* character,
	Driver* driver
	) {
	
	m_console = console;
	m_character = character;
	m_driver = driver;
}

Fighter::~Fighter() {
	delete m_driver;
	delete m_character;
}

void Fighter::Decision() {
	m_driver->Decision();
}

void Fighter::Render() {
	m_character->GetActor()->Render();
}

bool Fighter::CanBeRemoved() {
	return m_character->GetActor()->CanBeRemoved();
}

Character* Fighter::GetCharacter() {
	return m_character;
}