#ifndef __FIGHTER_H
#define __FIGHTER_H

#include "../core/core.h"
#include "../characters/characters.h"
#include "../drivers/drivers.h"

/*
	Top-most level representation of a fighter who can act and has statistics
	
	NOTE: Deletes characters and drivers
*/
class Fighter {
	
	private:
	
	Console* m_console;
	Character* m_character;
	Driver* m_driver;
	
	public:
	
	Fighter(
		Console* console,
		Character* character,
		Driver* driver
		);

	virtual ~Fighter();
	
	Character* GetCharacter();
	bool CanBeRemoved();
	void Decision();
	void Render();
};

#endif