#ifndef __FIGHTER_FACTORY_H
#define __FIGHTER_FACTORY_H

#include "../core/core.h"
#include "../actors/actors.h"
#include "../spawning/spawning.h"
#include "FighterTypes.h"
#include "Fighter.h"

/*
	Makes fighters
*/
class FighterFactory {
	
	private:
	
	Console* m_console;
	CompositeActorFactory* m_compositeActorFactory;
	CharacterFactory* m_characterFactory;
	DriverFactory* m_driverFactory;
	
	Fighter* Helper_Create(
		FighterTypes type,
		Scroller* scroller,
		Coords_F position
		);
	
	public:
	
	FighterFactory(
		Console* console,
		CompositeActorFactory* compositeActorFactory,
		CharacterFactory* characterFactory,
		DriverFactory* driverFactory
		);

	virtual ~FighterFactory();
	
	Fighter* CreatePlayer(
		Scroller* scroller,
		s16 initialLife,
		s16 initialEnergy
		);
	
	Fighter* CreateFromSpawn(
		Spawn* spawn,
		Scroller* scroller
		);
};

#endif