#include "GoFrameDescriptor.h"

GoFrameDescriptor::GoFrameDescriptor( Console* console ) {

	m_console = console;

	m_phaseLengths[ 0 ] = 4;
	
	m_phaseVideoFramePerAnimationFrame[ 0 ] = 5;
}

GoFrameDescriptor::~GoFrameDescriptor() {
}

u8 GoFrameDescriptor::GetPhaseCount() {
	return PHASE_COUNT;
}

u8 GoFrameDescriptor::GetPhaseFramesCount( u8 phase ) {
	
	if( phase >= PHASE_COUNT ) {
		m_console->Error( "[GoFrameDescriptor]GetPhaseLength: Invalid phase: %d at %p", phase, this );
	}
	
	return m_phaseLengths[ phase ];
}

u8 GoFrameDescriptor::GetPhaseVideoFramePerAnimationFrame( u8 phase ) {

	if( phase >= PHASE_COUNT ) {
		m_console->Error( 
			"[GoFrameDescriptor]GetPhaseVideoFramePerAnimationFrame: Invalid phase: %d at %p", phase, this 
			);
	}
	
	return m_phaseVideoFramePerAnimationFrame[ phase ];
}
