#ifndef PHASES_H
#define PHASES_H

// animation phases common to all characters
enum CommonPhases {
	PHASE_WALKING = 0,
	PHASE_STANDING = 1,
	PHASE_GETTING_UP = 2,
	PHASE_FALLING_DOWN = 3,
	PHASE_HIT_RECOVERY = 4,
	PHASE_SINGLE_HIT = 5 // a regular attack for enemies
						 // a power attack for player
};

// animation phases specific to the player
enum PlayerPhases {
	PLAYER_PHASE_HEAL = 6, // player's self-heal
	PLAYER_PHASE_MYSTICAL = 7, // player's all-screen damage move
	
	PLAYER_PHASE_COMBO_ONE = 8, // player combo parts
	PLAYER_PHASE_COMBO_TWO = 9,
	PLAYER_PHASE_COMBO_THREE = 10,
	PLAYER_PHASE_COMBO_FOUR = 11,
	
	PLAYER_PHASE_COUNT = 12
};

// animation phases specific to enemies
enum EnemyPhases {
	ENEMY_PHASE_ALTERNATE_HIT = 6, // an alternate attack for enemies
	ENEMY_PHASE_CHARGE = 7, // a charge attack for enemies
	
	ENEMY_PHASE_COUNT = 8
};

#endif