#include "PlayerFrameDescriptor.h"

PlayerFrameDescriptor::PlayerFrameDescriptor( Console* console ) {

	m_console = console;

	m_phaseLengths[ PHASE_WALKING ] = 4;
	m_phaseLengths[ PHASE_STANDING ] = 4;
	m_phaseLengths[ PHASE_GETTING_UP ] = 4;
	m_phaseLengths[ PHASE_FALLING_DOWN ] = 4;
	m_phaseLengths[ PHASE_HIT_RECOVERY ] = 3;
	m_phaseLengths[ PHASE_SINGLE_HIT ] = 4;
	m_phaseLengths[ PLAYER_PHASE_HEAL ] = 4;
	m_phaseLengths[ PLAYER_PHASE_MYSTICAL ] = 4;
	
	m_phaseLengths[ PLAYER_PHASE_COMBO_ONE ] = 4;
	m_phaseLengths[ PLAYER_PHASE_COMBO_TWO ] = 4;
	m_phaseLengths[ PLAYER_PHASE_COMBO_THREE ] = 4;
	m_phaseLengths[ PLAYER_PHASE_COMBO_FOUR ] = 4;
	
	m_phaseVideoFramePerAnimationFrame[ PHASE_WALKING ] = 10;
	m_phaseVideoFramePerAnimationFrame[ PHASE_STANDING ] = 15;
	m_phaseVideoFramePerAnimationFrame[ PHASE_GETTING_UP ] = 12;
	m_phaseVideoFramePerAnimationFrame[ PHASE_FALLING_DOWN ] = 15;
	m_phaseVideoFramePerAnimationFrame[ PHASE_HIT_RECOVERY ] = 8;
	m_phaseVideoFramePerAnimationFrame[ PHASE_SINGLE_HIT ] = 11;
	m_phaseVideoFramePerAnimationFrame[ PLAYER_PHASE_HEAL ] = 15;
	m_phaseVideoFramePerAnimationFrame[ PLAYER_PHASE_MYSTICAL ] = 10;
	m_phaseVideoFramePerAnimationFrame[ PLAYER_PHASE_COMBO_ONE ] = 5;
	m_phaseVideoFramePerAnimationFrame[ PLAYER_PHASE_COMBO_TWO ] = 5;
	m_phaseVideoFramePerAnimationFrame[ PLAYER_PHASE_COMBO_THREE ] = 5;	
	m_phaseVideoFramePerAnimationFrame[ PLAYER_PHASE_COMBO_FOUR ] = 5;	
}

PlayerFrameDescriptor::~PlayerFrameDescriptor() {
}

u8 PlayerFrameDescriptor::GetPhaseCount() {
	return PHASE_COUNT;
}

u8 PlayerFrameDescriptor::GetPhaseFramesCount( u8 phase ) {
	
	if( phase >= PHASE_COUNT ) {
		m_console->Error( "[PlayerFrameDescriptor]GetPhaseLength: Invalid phase: %d at %p", phase, this );
	}
	
	return m_phaseLengths[ phase ];
}

u8 PlayerFrameDescriptor::GetPhaseVideoFramePerAnimationFrame( u8 phase ) {

	if( phase >= PHASE_COUNT ) {
		m_console->Error( 
			"[PlayerFrameDescriptor]GetPhaseVideoFramePerAnimationFrame: Invalid phase: %d at %p", phase, this 
			);
	}
	
	return m_phaseVideoFramePerAnimationFrame[ phase ];
}
