#ifndef __PLAYERFRAMEDESCRIPTOR_H
#define __PLAYERFRAMEDESCRIPTOR_H

#include "../core/core.h"
#include "FrameDescriptor.h"
#include "Phases.h"

class PlayerFrameDescriptor : public FrameDescriptor {

	private:
	
	static const u8 PHASE_COUNT = PLAYER_PHASE_COUNT;
	
	u8 m_phaseLengths[ PHASE_COUNT ];
	u8 m_phaseVideoFramePerAnimationFrame[ PHASE_COUNT ];
	
	Console* m_console;

	public:
	
	PlayerFrameDescriptor( Console* console );
	virtual ~PlayerFrameDescriptor();
	
	u8 GetPhaseCount();
	u8 GetPhaseFramesCount( u8 phase );
	u8 GetPhaseVideoFramePerAnimationFrame( u8 phase );
};

#endif