#include "SmecherFrameDescriptor.h"

SmecherFrameDescriptor::SmecherFrameDescriptor( Console* console ) {

	m_console = console;

	m_phaseLengths[ PHASE_WALKING ] = 4;
	m_phaseLengths[ PHASE_STANDING ] = 4;
	m_phaseLengths[ PHASE_GETTING_UP ] = 4;
	m_phaseLengths[ PHASE_FALLING_DOWN ] = 4;
	m_phaseLengths[ PHASE_HIT_RECOVERY ] = 3;
	m_phaseLengths[ PHASE_SINGLE_HIT ] = 4;
	m_phaseLengths[ ENEMY_PHASE_ALTERNATE_HIT ] = 4;
	
	m_phaseVideoFramePerAnimationFrame[ PHASE_WALKING ] = 11;
	m_phaseVideoFramePerAnimationFrame[ PHASE_STANDING ] = 10;
	m_phaseVideoFramePerAnimationFrame[ PHASE_GETTING_UP ] = 12;
	m_phaseVideoFramePerAnimationFrame[ PHASE_FALLING_DOWN ] = 15;
	m_phaseVideoFramePerAnimationFrame[ PHASE_HIT_RECOVERY ] = 8;
	m_phaseVideoFramePerAnimationFrame[ PHASE_SINGLE_HIT ] = 6;
	m_phaseVideoFramePerAnimationFrame[ ENEMY_PHASE_ALTERNATE_HIT ] = 6;
}

SmecherFrameDescriptor::~SmecherFrameDescriptor() {
}

u8 SmecherFrameDescriptor::GetPhaseCount() {
	return PHASE_COUNT;
}

u8 SmecherFrameDescriptor::GetPhaseFramesCount( u8 phase ) {
	
	if( phase >= PHASE_COUNT ) {
		m_console->Error( "[SmecherFrameDescriptor]GetPhaseLength: Invalid phase: %d at %p", phase, this );
	}
	
	return m_phaseLengths[ phase ];
}

u8 SmecherFrameDescriptor::GetPhaseVideoFramePerAnimationFrame( u8 phase ) {

	if( phase >= PHASE_COUNT ) {
		m_console->Error( 
			"[SmecherFrameDescriptor]GetPhaseVideoFramePerAnimationFrame: Invalid phase: %d at %p", phase, this 
			);
	}
	
	return m_phaseVideoFramePerAnimationFrame[ phase ];
}
