#include "GaugeFactory.h"

GaugeFactory::GaugeFactory( 
	SpriteManager* spriteManager
	) {
	m_spriteManager = spriteManager;
}

GaugeFactory::~GaugeFactory() {
}

Gauge* GaugeFactory::Create( float yPosition ) {
	Coords_F position( 0.0f, yPosition );
	return new SimpleGauge( position, m_spriteManager );
}

Gauge* GaugeFactory::CreateReversed( float yPosition ) {
	Coords_F position( 128.0f, yPosition );
	return new ReversedGauge( position, m_spriteManager );
}