#ifndef __TRANSITION_H
#define __TRANSITION_H

#include <nds.h>
#include "../core/core.h"
#include "../animators/animators.h"
#include "../actors/actors.h"
#include "../drivers/drivers.h"
#include "../characters/characters.h"
#include "../fighters/fighters.h"
#include "../backgrounds/backgrounds.h"
#include "../spawning/spawning.h"
#include "FighterListEmptyFuncBool.h"
#include "../gauges/gauges.h"
#include "../movehints/movehints.h"
#include "../playerviews/playerviews.h"
#include "../enemyviews/enemyviews.h"

/*
	A controller for a transition between levels, splash screens, etc; 
	basically anything where there's no gameplay, and from which the user
	progresses by pressing START
*/
class Transition : public FrameRunner {
	
	private:

	CoreUtils* m_coreUtils;
	Console* m_console;
	StageBackground* m_background;
	InputManager* m_inputManager;
	FuncBool* m_trueFuncBool;
	
	bool m_isDone;
	u8 m_outroFrames;
	
	protected:
	
	bool IsDone();
	
	public:
	
	Transition(
		CoreUtils* coreUtils,
		Console* console,
		BackgroundFactory* backgroundFactory,
		InputManager* inputManager,
		BackgroundTypes type
		);
	virtual ~Transition();
	
	FrameRunnerResult GetResult();
	void Pre();
	void Frame();
	void Post();
};

#endif