#include "MoveHint.h"

MoveHint::MoveHint( 
	s16 powerStrikeThreshold,
	s16 healAndMysticalThreshold,
	Coords_F position,
	SpriteManager* spriteManager
	) {
	
	m_powerStrikeThreshold = powerStrikeThreshold;
	m_healAndMysticalThreshold = healAndMysticalThreshold;
	
	m_sprite = spriteManager->AllocateSubScreenSprite();
	m_sprite->MoveToUnchecked( position );
	
	this->SetValue( 0 );
}

MoveHint::~MoveHint() {
	delete m_sprite;
}

void MoveHint::SetValue( 
	s16 value
	) {
	
	if( value >= m_healAndMysticalThreshold ) {
		m_sprite->ChangeFrame( 1, 3 );
	} else if( value >= m_powerStrikeThreshold ) {
		m_sprite->ChangeFrame( 1, 2 );
	} else {
		m_sprite->ChangeFrame( 1, 1 );
	}
}

void MoveHint::Render() {
	m_sprite->Render();
}

void MoveHint::Hide() {
	m_sprite->ChangeFrame( 0, 3 );
}