#ifndef __MOVE_HINT_H
#define __MOVE_HINT_H

#include <nds.h>
#include "../core/core.h"

/*
	Used to give player hints of possible moves which can be performed
*/
class MoveHint {

	private:
	
	s16 m_powerStrikeThreshold;
	s16 m_healAndMysticalThreshold;

	s16 m_value;
	OAMSprite* m_sprite;
	
	public:
	
	MoveHint( 
		s16 powerStrikeThreshold,
		s16 healAndMysticalThreshold,
		Coords_F position,
		SpriteManager* spriteManager
		);
	virtual ~MoveHint();
	
	void SetValue( 
		s16 value
		);
	void Hide();

	void Render();
};

#endif