#include "MoveHintFactory.h"

MoveHintFactory::MoveHintFactory( 
	SpriteManager* spriteManager
	) {
	m_spriteManager = spriteManager;
}

MoveHintFactory::~MoveHintFactory() {
}

MoveHint* MoveHintFactory::Create( 
	Coords_F position,
	Fighter* fighter
	) {
	
	CharacterProperties* properties = 
		fighter->GetCharacter()->GetProperties();
	
	return new MoveHint( 
		properties->GetPowerStrikeEnergyCost(),
		properties->GetHealAndMysticalEnergyCost(),
		position, 
		m_spriteManager 
		);
}
