#include "MugShot.h"

MugShot::MugShot( 
	Coords_F position,
	SpriteManager* spriteManager
	) {
	
	m_sprite = spriteManager->AllocateSubScreenSprite();
	this->Hide();
	m_sprite->MoveToUnchecked( position );
}

MugShot::~MugShot() {
	delete m_sprite;
}

void MugShot::SetType( 
	CharacterTypes type
	) {
	
	switch( type ) {
		case PLAYER_CHARACTER:
			m_sprite->ChangeFrame( 2, 0 );
			return;
			
		case SMECHER_CHARACTER:
			m_sprite->ChangeFrame( 2, 1 );
			return;
		case SMECHER_CHARACTER_BLUE:
			m_sprite->ChangeFrame( 2, 2 );
			return;
		case SMECHER_CHARACTER_GREEN:
			m_sprite->ChangeFrame( 2, 3 );
			return;
		case SMECHER_CHARACTER_PURPLE:
			m_sprite->ChangeFrame( 3, 3 );
			return;
		case SMECHER_CHARACTER_RED:
			m_sprite->ChangeFrame( 3, 2 );
			return;
		
		case CUTITAR_CHARACTER_BOSS:
		case CUTITAR_CHARACTER:
			m_sprite->ChangeFrame( 4, 3 );
			return;
			
		case MASCAT_CHARACTER:
			m_sprite->ChangeFrame( 4, 2 );
			return;
		case MASCAT_CHARACTER_GREEN:
			m_sprite->ChangeFrame( 4, 1 );
			return;
		case MASCAT_CHARACTER_RED:
			m_sprite->ChangeFrame( 4, 0 );
			return;
			
		case MEISS_CHARACTER:
		case MEISS_CHARACTER_BOSS:
			m_sprite->ChangeFrame( 3, 0 );
			return;
		case MEISS_CHARACTER_DARK:
			m_sprite->ChangeFrame( 3, 1 );
			return;
	}
	
	this->Hide();
}

void MugShot::Hide() {
	m_sprite->ChangeFrame( 0, 3 );
}

void MugShot::Render() {
	m_sprite->Render();
}
