#include "Go.h"

Go::Go(
	Console* console,
	SpriteManager* spriteManager,
	AnimatorFactory* animatorFactory
	) {
	
	// deleted by animator
	OAMSprite* sprite = spriteManager->AllocateMainScreenSprite( 
		(u8*) goAnimationTiles, 
		256, 
		(u8*) goAnimationPal
		);
	sprite->SetPriorityHigh();
	// deleted by animator
	FrameDescriptor* frameDescriptor = new GoFrameDescriptor( console );
	
	m_animator = animatorFactory->Create( sprite, frameDescriptor );
	m_animator->ChangePhase( 0 );
	
	this->Hide();
}

Go::~Go() {
	delete m_animator;
}

void Go::Show() {
	Coords_F position( 190.0f, 64.0f );
	m_animator->GetSprite()->MoveToUnchecked( position );
}

void Go::Render() {
	m_animator->AdvanceFrame();
	m_animator->Render();
}

void Go::Hide() {
	Coords_F offscreen( 256.0f, 0.0f );
	m_animator->GetSprite()->MoveToUnchecked( offscreen );
}