#ifndef __IMPACT_H
#define __IMPACT_H

#include <impactAnimation.h>
#include "../core/core.h"

/*
	Displays a small overlay for when strikes occur
*/
class Impact {

	private:
	
	static const u8 FRAME_COUNT = 4;
	static const u8 VIDEO_FRAMES_PER_ANIMATION = 2;
	static const u8 MAX_FRAMES = VIDEO_FRAMES_PER_ANIMATION * FRAME_COUNT;
	OAMSprite* m_sprite;
	CoreUtils* m_coreUtils;
	u8 m_frameCounter;
	
	void Hide();
	
	public:
	
	Impact( 
		SpriteManager* spriteManager,
		CoreUtils* coreUtils
		);
	virtual ~Impact();
	
	void ShowForPosition( 
		Coords_F position,
		bool isFacingRight
		);
	void Render();
};

#endif