#ifndef __PLAYER_VIEW_H
#define __PLAYER_VIEW_H

#include <nds.h>
#include "../core/core.h"
#include "../gauges/gauges.h"
#include "../movehints/movehints.h"
#include "../fighters/fighters.h"
#include "../mugshots/mugshots.h"

/*
	Displays player details
*/
class PlayerView {

	private:

	static const u8 LIFE_COLUMN = 4;
	static const u8 ENERGY_COLUMN = 23;
	static const u8 LIFE_ENERGY_ROW = 22;
	
	Console* m_console;
	Fighter* m_player;
	Gauge* m_lifeGauge;
	Gauge* m_energyGauge;
	MoveHint* m_moveHint;
	MugShot* m_mugShot;
	
	public:
	
	PlayerView( 
		Console* console,
		GaugeFactory* gaugeFactory,
		MoveHintFactory* moveHintFactory,
		MugShotFactory* mugShotFactory,
		Fighter* player
		);
	virtual ~PlayerView();
	
	void Update();
	void Render();
};

#endif