#include "PlayerViewFactory.h"

PlayerViewFactory::PlayerViewFactory( 
	Console* console,
	GaugeFactory* gaugeFactory,
	MoveHintFactory* moveHintFactory,
	MugShotFactory* mugShotFactory
	) {
	
	m_console = console;
	m_gaugeFactory = gaugeFactory;
	m_moveHintFactory = moveHintFactory;
	m_mugShotFactory = mugShotFactory;
}

PlayerViewFactory::~PlayerViewFactory() {
}

PlayerView* PlayerViewFactory::Create( Fighter* player ) {
	return new PlayerView( 
		m_console,
		m_gaugeFactory,
		m_moveHintFactory,
		m_mugShotFactory,
		player
		);
}
