#ifndef __PLAYER_VIEW_FACTORY_H
#define __PLAYER_VIEW_FACTORY_H

#include <nds.h>
#include "../core/core.h"
#include "../fighters/fighters.h"
#include "../mugshots/mugshots.h"
#include "PlayerView.h"

/*
	Makes player views
*/
class PlayerViewFactory {
	
	private:
	
	Console* m_console;
	GaugeFactory* m_gaugeFactory;
	MoveHintFactory* m_moveHintFactory;
	MugShotFactory* m_mugShotFactory;
	
	public:
	
	PlayerViewFactory(
		Console* console,
		GaugeFactory* gaugeFactory,
		MoveHintFactory* moveHintFactory,
		MugShotFactory* mugShotFactory
		);
	virtual ~PlayerViewFactory();
	
	PlayerView* Create( Fighter* player );
};

#endif