#include "PlayerSoundboard.h"
#include "soundbank.h"

PlayerSoundboard::PlayerSoundboard( 
	CoreUtils* coreUtils,
	SoundHolder* soundHolder
	) : Soundboard( coreUtils, soundHolder ) 
	{
	
	m_hitLand[ 0 ] = m_soundHolder->GetHitLand2();
	m_hitLand[ 1 ] = m_soundHolder->GetHitLand5();
}

PlayerSoundboard::~PlayerSoundboard() {
}

void PlayerSoundboard::StartSingleHit() {
	m_soundHolder->GetStartSinglePlayer()->Play();
}

void PlayerSoundboard::SingleHitLanded() {
	m_soundHolder->GetHitLandBig()->Play();
}

void PlayerSoundboard::WasThrownDown() {
	m_soundHolder->GetThrown4()->Play();
}

void PlayerSoundboard::StartComboHit() {
	m_soundHolder->GetWoosh()->Play();
}

void PlayerSoundboard::ComboHitLanded() {
	PlayOne( &m_hitLand[ 0 ], NUM_HITLAND );
}

void PlayerSoundboard::Heal() {
	m_soundHolder->GetHeal()->Play();
}

void PlayerSoundboard::Mystical() {
	m_soundHolder->GetMystical()->Play();
}
