#ifndef __PLAYER_SOUNDBOARD_H
#define __PLAYER_SOUNDBOARD_H

#include <nds.h>
#include "../core/core.h"
#include "SoundHolder.h"
#include "Soundboard.h"

/*
	Sounds for the player
*/
class PlayerSoundboard : public Soundboard {

	private:
	
	static const u8 NUM_HITLAND = 2;
	SoundEffect* m_hitLand[ NUM_HITLAND ];

	public:
	
	PlayerSoundboard( 
		CoreUtils* coreUtils,
		SoundHolder* soundHolder
		);
	virtual ~PlayerSoundboard();
	
	void StartSingleHit();
	void SingleHitLanded();
	
	void WasThrownDown();
	
	void StartComboHit();
	void ComboHitLanded();
	
	void Heal();
	void Mystical();
};

#endif