#include "SoundHolder.h"
#include "soundbank.h"

SoundHolder::SoundHolder( 
	Console* console,
	AudioPlayer* audioPlayer
	) {
	
	m_console = console;
	m_audioPlayer = audioPlayer;
	
	m_charge1 = m_audioPlayer->LoadSoundEffect( SFX_CHARGE1 );
	m_charge2 = m_audioPlayer->LoadSoundEffect( SFX_CHARGE2 );
	m_click = m_audioPlayer->LoadSoundEffect( SFX_CLICK );
	m_heal = m_audioPlayer->LoadSoundEffect( SFX_HEAL );
	m_mystical = m_audioPlayer->LoadSoundEffect( SFX_MYSTICAL );
	
	m_hitland1 = m_audioPlayer->LoadSoundEffect( SFX_HITLAND1 );
	m_hitland2 = m_audioPlayer->LoadSoundEffect( SFX_HITLAND2 );
	m_hitland3 = m_audioPlayer->LoadSoundEffect( SFX_HITLAND3 );
	m_hitland4 = m_audioPlayer->LoadSoundEffect( SFX_HITLAND4 );
	m_hitland5 = m_audioPlayer->LoadSoundEffect( SFX_HITLAND5 );
	m_hitlandbig = m_audioPlayer->LoadSoundEffect( SFX_HITLANDBIG );
	
	m_knifeHit1 = m_audioPlayer->LoadSoundEffect( SFX_KNIFE_HIT1 );
	m_knifeHit2 = m_audioPlayer->LoadSoundEffect( SFX_KNIFE_HIT2 );
	m_startSingleMeiss = m_audioPlayer->LoadSoundEffect( SFX_STARTSINGLE_MEISS );
	m_startSinglePlayer = m_audioPlayer->LoadSoundEffect( SFX_STARTSINGLE_PLAYER );
	m_thrown2 = m_audioPlayer->LoadSoundEffect( SFX_THROWN2 );
	m_thrown3 = m_audioPlayer->LoadSoundEffect( SFX_THROWN3 );
	m_thrown4 = m_audioPlayer->LoadSoundEffect( SFX_THROWN4 );
	m_thrown5 = m_audioPlayer->LoadSoundEffect( SFX_THROWN5 );
	m_thrown8 = m_audioPlayer->LoadSoundEffect( SFX_THROWN8 );
	m_woosh = m_audioPlayer->LoadSoundEffect( SFX_WOOSH );
}

SoundHolder::~SoundHolder() {
	delete m_charge1;
	delete m_charge2;
	delete m_click;
	delete m_heal;
	delete m_mystical;
	delete m_hitland1;
	delete m_hitland2;
	delete m_hitland3;
	delete m_hitland4;
	delete m_hitland5;
	delete m_hitlandbig;
	delete m_knifeHit1;
	delete m_knifeHit2;
	delete m_startSingleMeiss;
	delete m_startSinglePlayer;
	delete m_thrown2;
	delete m_thrown3;
	delete m_thrown4;
	delete m_thrown5;
	delete m_thrown8;
	delete m_woosh;
}

SoundEffect* SoundHolder::GetWoosh() {
	return m_woosh;
}

SoundEffect* SoundHolder::GetHitLand1() {
	return m_hitland1;
}
SoundEffect* SoundHolder::GetHitLand2() {
	return m_hitland2;
}
SoundEffect* SoundHolder::GetHitLand3() {
	return m_hitland3;
}
SoundEffect* SoundHolder::GetHitLand4() {
	return m_hitland4;
}
SoundEffect* SoundHolder::GetHitLand5() {
	return m_hitland5;
}
SoundEffect* SoundHolder::GetHitLandBig() {
	return m_hitlandbig;
}

SoundEffect* SoundHolder::GetKnifeHit1() {
	return m_knifeHit1;
}
SoundEffect* SoundHolder::GetKnifeHit2() {
	return m_knifeHit2;
}

SoundEffect* SoundHolder::GetStartSinglePlayer() {
	return m_startSinglePlayer;
}
SoundEffect* SoundHolder::GetStartSingleMeiss() {
	return m_startSingleMeiss;
}

SoundEffect* SoundHolder::GetHeal() {
	return m_heal;
}
SoundEffect* SoundHolder::GetMystical() {
	return m_mystical;
}

SoundEffect* SoundHolder::GetCharge1() {
	return m_charge1;
}
SoundEffect* SoundHolder::GetCharge2() {
	return m_charge2;
}

SoundEffect* SoundHolder::GetThrown2() {
	return m_thrown2;
}
SoundEffect* SoundHolder::GetThrown3() {
	return m_thrown3;
}
SoundEffect* SoundHolder::GetThrown4() {
	return m_thrown4;
}
SoundEffect* SoundHolder::GetThrown5() {
	return m_thrown5;
}
SoundEffect* SoundHolder::GetThrown8() {
	return m_thrown8;
}

SoundEffect* SoundHolder::GetClick() {
	return m_click;
}