#ifndef __SOUNDHOLDER_H
#define __SOUNDHOLDER_H

#include <nds.h>
#include "../core/core.h"

/*
	Loads all sounds which will be in use throughout the game
*/
class SoundHolder {

	private:
	
	Console* m_console;
	AudioPlayer* m_audioPlayer;
	
	SoundEffect* m_charge1;
	SoundEffect* m_charge2;
	SoundEffect* m_click;
	SoundEffect* m_heal;
	SoundEffect* m_mystical;
	SoundEffect* m_hitland1;
	SoundEffect* m_hitland2;
	SoundEffect* m_hitland3;
	SoundEffect* m_hitland4;
	SoundEffect* m_hitland5;
	SoundEffect* m_hitlandbig;
	SoundEffect* m_knifeHit1;
	SoundEffect* m_knifeHit2;
	SoundEffect* m_startSingleMeiss;
	SoundEffect* m_startSinglePlayer;
	SoundEffect* m_thrown2;
	SoundEffect* m_thrown3;
	SoundEffect* m_thrown4;
	SoundEffect* m_thrown5;
	SoundEffect* m_thrown8;
	SoundEffect* m_woosh;
	
	public:
	
	SoundHolder( 
		Console* console,
		AudioPlayer* audioPlayer
		);
	virtual ~SoundHolder();
	
	SoundEffect* GetHeal();
	SoundEffect* GetMystical();
	
	SoundEffect* GetWoosh();
	
	SoundEffect* GetStartSinglePlayer();
	SoundEffect* GetStartSingleMeiss();
	
	SoundEffect* GetHitLand1();
	SoundEffect* GetHitLand2();
	SoundEffect* GetHitLand3();
	SoundEffect* GetHitLand4();
	SoundEffect* GetHitLand5();
	SoundEffect* GetHitLandBig();
	
	SoundEffect* GetKnifeHit1();
	SoundEffect* GetKnifeHit2();
	
	SoundEffect* GetCharge1();
	SoundEffect* GetCharge2();
	
	SoundEffect* GetThrown2();
	SoundEffect* GetThrown3();
	SoundEffect* GetThrown4();
	SoundEffect* GetThrown5();
	SoundEffect* GetThrown8();
	
	SoundEffect* GetClick();
};

#endif