#ifndef __SOUNDBOARD_FACTORY_H
#define __SOUNDBOARD_FACTORY_H

#include <nds.h>
#include "../core/core.h"
#include "SoundHolder.h"
#include "Soundboard.h"
#include "PlayerSoundboard.h"
#include "SmecherSoundboard.h"
#include "MeissSoundboard.h"
#include "CutitarSoundboard.h"
#include "MascatSoundboard.h"
#include "SoundboardTypes.h"
#include "UISoundboard.h"

/*
	Makes soundboards
*/
class SoundboardFactory {
	
	private:

	CoreUtils* m_coreUtils;
	Console* m_console;
	SoundHolder* m_soundHolder;
	
	PlayerSoundboard* m_playerSoundboard;
	SmecherSoundboard* m_smecherSoundboard;
	MeissSoundboard* m_meissSoundboard;
	CutitarSoundboard* m_cutitarSoundboard;
	MascatSoundboard* m_mascatSoundboard;
	
	UISoundboard* m_uiSoundboard;
	
	public:
	
	SoundboardFactory(
		CoreUtils* coreUtils,
		Console* console,
		AudioPlayer* audioPlayer
		);
	virtual ~SoundboardFactory();
	
	Soundboard* Get( SoundboardTypes type );
	UISoundboard* Get();
};

#endif