#ifndef __SPAWN_REGISTRY_H
#define __SPAWN_REGISTRY_H

#include "../core/core.h"
#include "Spawn.h"

/*
	Encapsulates a set of spawn information
*/
class SpawnRegistry {

	private:
	
	static const u8 MAX_VERTICAL_POSITIONS = 5;
	
	Console* m_console;
	float m_verticalPositions[ MAX_VERTICAL_POSITIONS ];
	s16 m_lastCheckedIndex;
	u8 m_spawnCount;
	Spawn** m_spawns;
	
	u8 m_additionCurrentIndex;

	protected:
	
	static const float LEFT = -63.0f;
	static const float RIGHT = 255.0f;
	
	void Add( 
		float x,
		float y,
		u16 scrollAmountToSpawn,
		FighterTypes type
		);
	
	public:
	
	SpawnRegistry( 
		Console* console,
		u8 spawnCount
		);
	virtual ~SpawnRegistry();
	
	// return number of spawns which have become available since the last 
	// checked scroll point
	u8 GetAvailableSpawnCount( u16 scrollPosition );
	// like above, but returns a pointer to the first
	Spawn** GetAvailableSpawns( u16 scrollPosition );
};

#endif