#include "SpawnRegistryFactory.h"

SpawnRegistryFactory::SpawnRegistryFactory( Console* console ) {
	m_console = console;
}

SpawnRegistryFactory::~SpawnRegistryFactory() {
}
	
SpawnRegistry* SpawnRegistryFactory::Create( SpawnRegistryTypes type ) {

	switch( type ) {
		
		case SR_CIRCUS_PARK_BUILDINGS:
			return new CircusParkBuildingsSpawnRegistry( m_console );
		case SR_CIRCUS_PARK_CIRCUS:
			return new CircusParkCircusSpawnRegistry( m_console );
		case SR_PEOPLES_HOUSE:
			return new PeoplesHouseSpawnRegistry( m_console );
		case SR_BROOKLYN_BRIDGE:
			return new BrooklynBridgeSpawnRegistry( m_console );
		case SR_STATUE_OF_LIBERTY:
			return new StatueOfLibertySpawnRegistry( m_console );
		case SR_PEOPLES_PARK:
			return new PeoplesParkSpawnRegistry( m_console );
		case SR_TEMPLE_OF_HEAVEN:
			return new TempleOfHeavenSpawnRegistry( m_console );
		case SR_SCOTLAND:
			return new ScotlandSpawnRegistry( m_console );
		case SR_WINDSOR:
			return new WindsorSpawnRegistry( m_console );
		case SR_CORE:
			return new CoreSpawnRegistry( m_console );
	}
	
	m_console->Error( "[SpawnRegistryFactory]Create: unrecognized type" );
	return NULL;
}