#ifndef __SPAWN_REGISTRY_FACTORY_H
#define __SPAWN_REGISTRY_FACTORY_H

#include "SpawnRegistry.h"
#include "SpawnRegistryTypes.h"
#include "CircusParkBuildingsSpawnRegistry.h"
#include "CircusParkCircusSpawnRegistry.h"
#include "PeoplesHouseSpawnRegistry.h"
#include "BrooklynBridgeSpawnRegistry.h"
#include "PeoplesParkSpawnRegistry.h"
#include "StatueOfLibertySpawnRegistry.h"
#include "TempleOfHeavenSpawnRegistry.h"
#include "ScotlandSpawnRegistry.h"
#include "WindsorSpawnRegistry.h"
#include "CoreSpawnRegistry.h"

/*
	Makes spawn registries
*/
class SpawnRegistryFactory {

	private:
	
	Console* m_console;

	public:
	
	SpawnRegistryFactory( Console* console );
	virtual ~SpawnRegistryFactory();
	
	SpawnRegistry* Create( SpawnRegistryTypes type );
};

#endif