#ifndef __TESTSCONSOLE_H__
#define __TESTSCONSOLE_H__

#include "../core/CustomFont.h"

/*
	A console used for testing. It locks up the CPU after printing its first Error,
	so that errors can be caught during test suite runs.
	
	Components under test receive a reference to this instead of the standard Console.
*/
class TestsConsole : public Console {

	private:
	
	public:
	
	TestsConsole( CoreUtils* coreUtils );
		
	virtual ~TestsConsole();
	
	// A variable-argumented pass through
	void Debug( const char * format, ... );
	
	// Output and lock up CPU
	void Error( const char * format, ... );
};



#endif
