#ifndef __TESTS_H
#define __TESTS_H

#include "../core/SpritePool.h"
#include "../core/OAMSprite.h"
#include "TestsConsole.h"
#include "../core/ScrollingBackground.h"
#include "../core/core.h"
#include "soundbank.h"
#include "TestsSpritePool.h"
#include "../actors/actors.h"
#include "../levels/levels.h"
#include "../soundboards/soundboards.h"

class TestsRunner {

	private:
	
	// keep sounds loaded in order to put more stress on the RAM,
	// since sound functionality is how a memory problem was identified
	SoundboardFactory* m_soundBoardFactory;
	AudioPlayer* m_audioPlayer;
	Console* m_console;
	CoreUtils* m_coreUtils;
	
	void T_SoundEffectsPlayedMoreTimesThanItsMultiplexingLimit();
	void T_SongStopPlayConstructDestroy();
	void T_SpriteAllocation_NoLeaks();
	void T_SubSpriteAllocation_NoLeaks();
	void T_SoundEffectsConcurrently();
	void T_Random();
	void T_SpritePoolReprioritization();
	void T_SpritePoolReprioritizedOnFreeSlot();
	void T_Actors();
	void T_Levels();
	
	public:
	
	TestsRunner();
	virtual ~TestsRunner();
	void Start();
};

#endif